
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char Lire_BP(void);

void Affiche_LCD(char *ligne0,char *ligne1);

unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);

void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);

void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);

int regle_HTR(unsigned char adresse,unsigned char Heure_ou_Date, char H_J, char mn_mois, int sec_annee);

unsigned char D2000_read(unsigned char adreemap);

void D2000_write(unsigned char adressmap, unsigned char data);

unsigned char Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);

unsigned char Menu_Select_Seringue(void);

unsigned int RegVitesse(unsigned int *unites,unsigned int *diziemes, unsigned int *centiemes);

unsigned char Menu_Select_Sens(void);

void ActiveTimer(void);

void DesactiveTimer(void);

#pragma used-

#pragma library ssi2.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#asm
   .equ __lcd_port=0x15
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

void lcd_control (unsigned char control);

#pragma used-
#pragma library lcd.lib

void main(void)
{  

char display_buffer_ligne0[17]; 	
char display_buffer_ligne1[17]; 	
unsigned char Aff=0, Aff_1=0;
unsigned char BP, Moteur, Etat;

PORTA=0x3F; 		        
DDRA=0x00;

PORTB=0x00;                 
DDRB=0x1f;

lcd_init(16);

sprintf(display_buffer_ligne0,"  TP2 PARABOLE  ");
sprintf(display_buffer_ligne1,"   SIMULATION   ");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
delay_ms(3000);

sprintf(display_buffer_ligne0,"   PROG CYCLE   ");

Etat = 0; Moteur = 0;

while(1)  
{

BP = (~PINA & 0b00011110);   

switch (Etat) 
{ 
case 0: Moteur = 0;
if (BP == 2)	Etat = 1;
else if (BP == 4)	Etat = 2;
else Etat = 0;
break;

case 1: Moteur = 1;  	                     
if (BP == 8) Etat= 0;		  	     
else Etat = 1;                 
break;

case 2: Moteur = 2;                      
if (BP == 16)	Etat = 0;               
else Etat = 2;	        
break;

default : Etat = 0;
} 

PORTB = Moteur;

if (Etat==1) {sprintf(display_buffer_ligne1,"  Rotation : H  ");Aff=0;}
else  if (Etat==0) {sprintf(display_buffer_ligne1,"  Arret Moteur  ");Aff=1;}
else {sprintf(display_buffer_ligne1,"  Rotation : AH ");Aff=2;}

if (Aff != Aff_1) {Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);Aff_1=Aff;}
};

}

